package test;


public class Start_NatImpl
extends Start
{
  static private aterm.ATerm pattern = null;

  protected aterm.ATerm getPattern() {
    return pattern;
  }
  private static int index_wsBefore = 0;
  private static int index_topNat = 1;
  private static int index_wsAfter = 2;
  private static int index_ambCnt = 3;

  public shared.SharedObject duplicate() {
    Start_Nat clone = new Start_Nat();
     clone.init(hashCode(), getAnnotations(), getAFun(), getArgumentArray());
    return clone;
  }

  protected aterm.ATermAppl make(aterm.AFun fun, aterm.ATerm[] i_args, aterm.ATermList annos) {
    return getPeanoFactory().makeStart_Nat(fun, i_args, annos);
  }
  static public void initializePattern()
  {
    pattern = getStaticFactory().parse("parsetree(appl(prod([cf(opt(layout)),cf(sort(\"Nat\")),cf(opt(layout))],sort(\"<START>\"),no-attrs),[<term>,<term>,<term>]),<int>)");
  }


  static public Start fromTerm(aterm.ATerm trm)
  {
    java.util.List children = trm.match(pattern);

    if (children != null) {
      Start tmp = getStaticPeanoFactory().makeStart_Nat(OptLayout.fromTerm( (aterm.ATerm) children.get(0)), Nat.fromTerm( (aterm.ATerm) children.get(1)), OptLayout.fromTerm( (aterm.ATerm) children.get(2)), (Integer) children.get(3));
      tmp.setTerm(trm);
      return tmp;
    }
    else {
      return null;
    }
  }

  public aterm.ATerm toTerm() {
    if(term == null) {
      java.util.List args = new java.util.LinkedList();
      args.add(((PeanoConstructor) getArgument(0)).toTerm());
      args.add(((PeanoConstructor) getArgument(1)).toTerm());
      args.add(((PeanoConstructor) getArgument(2)).toTerm());
      args.add(new Integer(((aterm.ATermInt) getArgument(3)).getInt()));
      setTerm(getFactory().make(getPattern(), args));
    }
    return term;
  }

  public boolean isNat()
  {
    return true;
  }

  public boolean hasWsBefore()
  {
    return true;
  }

  public boolean hasTopNat()
  {
    return true;
  }

  public boolean hasWsAfter()
  {
    return true;
  }

  public boolean hasAmbCnt()
  {
    return true;
  }


  public OptLayout getWsBefore()
  {
    return (OptLayout) this.getArgument(index_wsBefore) ;
  }

  public Start setWsBefore(OptLayout _wsBefore)
  {
    return (Start) super.setArgument(_wsBefore, index_wsBefore);
  }

  public Nat getTopNat()
  {
    return (Nat) this.getArgument(index_topNat) ;
  }

  public Start setTopNat(Nat _topNat)
  {
    return (Start) super.setArgument(_topNat, index_topNat);
  }

  public OptLayout getWsAfter()
  {
    return (OptLayout) this.getArgument(index_wsAfter) ;
  }

  public Start setWsAfter(OptLayout _wsAfter)
  {
    return (Start) super.setArgument(_wsAfter, index_wsAfter);
  }

  public Integer getAmbCnt()
  {
   return new Integer(((aterm.ATermInt) this.getArgument(index_ambCnt)).getInt());
  }

  public Start setAmbCnt(Integer _ambCnt)
  {
    return (Start) super.setArgument(getFactory().makeInt(_ambCnt.intValue()), index_ambCnt);
  }

  public aterm.ATermAppl setArgument(aterm.ATerm arg, int i) {
    switch(i) {
      case 0:
        if (! (arg instanceof OptLayout)) { 
          throw new RuntimeException("Argument 0 of a Start_Nat should have type OptLayout");
        }
        break;
      case 1:
        if (! (arg instanceof Nat)) { 
          throw new RuntimeException("Argument 1 of a Start_Nat should have type Nat");
        }
        break;
      case 2:
        if (! (arg instanceof OptLayout)) { 
          throw new RuntimeException("Argument 2 of a Start_Nat should have type OptLayout");
        }
        break;
      case 3:
        if (! (arg instanceof aterm.ATermInt)) { 
          throw new RuntimeException("Argument 3 of a Start_Nat should have type int");
        }
        break;
      default: throw new RuntimeException("Start_Nat does not have an argument at " + i );
    }
    return super.setArgument(arg, i);
  }

}
