package test;


public class OptLayout_PresentImpl
extends OptLayout
{
  static private aterm.ATerm pattern = null;

  protected aterm.ATerm getPattern() {
    return pattern;
  }
  private static int index_chars = 0;

  public shared.SharedObject duplicate() {
    OptLayout_Present clone = new OptLayout_Present();
     clone.init(hashCode(), getAnnotations(), getAFun(), getArgumentArray());
    return clone;
  }

  protected aterm.ATermAppl make(aterm.AFun fun, aterm.ATerm[] i_args, aterm.ATermList annos) {
    return getPeanoFactory().makeOptLayout_Present(fun, i_args, annos);
  }
  static public void initializePattern()
  {
    pattern = getStaticFactory().parse("appl(prod([cf(layout)],cf(opt(layout)),no-attrs),<term>)");
  }


  static public OptLayout fromTerm(aterm.ATerm trm)
  {
    java.util.List children = trm.match(pattern);

    if (children != null) {
      OptLayout tmp = getStaticPeanoFactory().makeOptLayout_Present(CHARLIST.fromTerm( (aterm.ATerm) children.get(0)));
      tmp.setTerm(trm);
      return tmp;
    }
    else {
      return null;
    }
  }

  public boolean isPresent()
  {
    return true;
  }

  public boolean hasChars()
  {
    return true;
  }


  public CHARLIST getChars()
  {
    return (CHARLIST) this.getArgument(index_chars) ;
  }

  public OptLayout setChars(CHARLIST _chars)
  {
    return (OptLayout) super.setArgument(_chars, index_chars);
  }

  public aterm.ATermAppl setArgument(aterm.ATerm arg, int i) {
    switch(i) {
      case 0:
        if (! (arg instanceof CHARLIST)) { 
          throw new RuntimeException("Argument 0 of a OptLayout_Present should have type CHARLIST");
        }
        break;
      default: throw new RuntimeException("OptLayout_Present does not have an argument at " + i );
    }
    return super.setArgument(arg, i);
  }

  protected int hashFunction() {
    int c = 0 + (getAnnotations().hashCode()<<8);
    int a = 0x9e3779b9;
    int b = 0x9e3779b9;
    a += (getArgument(0).hashCode() << 0);

    a -= b; a -= c; a ^= (c >> 13);
    b -= c; b -= a; b ^= (a << 8);
    c -= a; c -= b; c ^= (b >> 13);
    a -= b; a -= c; a ^= (c >> 12);
    b -= c; b -= a; b ^= (a << 16);
    c -= a; c -= b; c ^= (b >> 5);
    a -= b; a -= c; a ^= (c >> 3);
    b -= c; b -= a; b ^= (a << 10);
    c -= a; c -= b; c ^= (b >> 15);

    return c;
  }
}
